<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for RandomComparator.
 * Generated by PHPUnit on 2012-07-03 at 17:40:23.
 * @group directory_iterators
 */
class RandomComparatorTest extends \PHPUnit_Framework_TestCase {

    /** @var RandomComparator */
    private $comparator;
    /** @var Treewec\DirectoryIterators\IteratorElement */
    private $iteratorElement;


    protected function setUp() {
        $this->comparator = new RandomComparator();
        $this->iteratorElement = new IteratorElement(0, new \SplFileInfo(TREEWEC_VIEW_DIR));
    }

    public function testCompare() {
        $numberOfIterations = 100;
        $results = array();
        $previous = 0;
        for ($i = 0; $i < $numberOfIterations; $i++) {
            $result = $this->comparator->compare($this->iteratorElement, $this->iteratorElement);
            $results[] = $result != $previous;
            $previous = $result;
        }        
        $countIsDifferentThanPrevious = count(array_filter($results, 'strlen'));
        if ($countIsDifferentThanPrevious < ($numberOfIterations / 2)) {
            echo "\n**********\n{$countIsDifferentThanPrevious}\n**************\n";
        }
        parent::assertTrue($countIsDifferentThanPrevious >= ($numberOfIterations * 0.4));
    }

}

?>